#ifndef GRID_H_
#define GRID_H_
#include "matriz.h"
/*
 * Contem todas as informacoes a respeito de uma malha com variaveis localizadas nos ns
 * v -> variavel a ser resolvida										*Apenas para a malha mais fina*
 * v_old -> variavel a ser resolvida no instante de tempo anterior		*Apenas para a malha mais fina*
 * c -> correcao
 * r -> residuo
 * X -> contem os valores (Xi,Yj) da malha cartesiana para cada ponto
 */
struct par{
	double x,y;
};

class Grid{
	private:
		unsigned int 	nx,	ny; //Numero de divisoes em X e Y respectivamente
		double			hx,	hy; //Distancia do espacamento entre 2 variaveis
		bool finest;
		
	public:
		Matriz<double> 	r,
						r_temp,
						c,
						v,
						v_old;
		
		Matriz<par> 	X;

		const unsigned int get_nx(){return nx;}
		const unsigned int get_ny(){return ny;}
		const double get_hx(){return hx;}
		const double get_hy(){return hy;}
		const bool is_finest(){return finest;} //indica se o grid e' o mais refinado
			
		Grid(int _nx, int _ny);
		~Grid();
			
		void create_fine_grid();
};

#endif /*GRID_H_*/
