#include <iostream>
#include <vector>
#include <math.h>
#include "grid.h"
#include "multigrid.h"
#include "time.h"
using namespace std;

static const double tempo_inicial	= 0.0;
static const double tempo_final		= 0.1;

int main(){
	vector<Grid*> Grids;
	Grid* temp_grid;
	int i,j, nx_fine, ny_fine;
	double hx,hy,ht;
	double tempo;
	
	time_t sec_ini,sec_fin;
	
	cout << endl << "Divisao do eixo x (multiplo de 2):";	cin >> nx_fine;
	cout << endl << "Divisao do eixo y (multiplo de 2):";	cin >> ny_fine;
			
	//cria as malhas
	while(nx_fine >= 2 && ny_fine >= 2)
	{
		temp_grid = new Grid(nx_fine, ny_fine);
		Grids.push_back(temp_grid);
		cout << "Malha:" << nx_fine << "x" << ny_fine << " criada" << endl;	
		nx_fine /= 2;
		ny_fine /= 2;
	}
	
	Grids[0]->create_fine_grid();
	
	//pega hx e hy da malha mais fina
	hx = Grids[0]->get_hx();
	hy = Grids[0]->get_hy();
	
	if(hx > hy) //ht = max(hx,hy)
		ht = hx;
	else
		ht = hy;

	//ht *= ht;  // -> para observar comportamento de 2 ordem

	Multigrid multi(Grids, ht, tempo_inicial, tempo_final);
	multi.inicializar_vetores(tempo_inicial);
	
	cout << "Tempo inicial:" << 0 << endl;
	
	sec_ini = time( NULL ); //inicia tempo de execucao
	tempo = tempo_inicial;
	i=0;
	do{
		tempo += ht;
		i++;
		if(i==10){
			i=0;
			cout << tempo << endl;
		}
		
		multi.atualizar_cc( tempo + ht );
		
		//Executa V-Ciclos	
		j=1;
		do{
			multi.V_ciclo(2, 1, tempo);
			//cout << "V-Ciclo " << j << "    Residuo maximo:" << multi.max_residuo(multi.Grids[0]) << endl;
			j++;
		}while(fabs(multi.max_residuo(multi.Grids[0])) > 10e-19 && j < 50);

		if( ht > (tempo_final - tempo) )	// ht = min( ht , T - t_atual )
			ht = tempo_final - tempo;
	}
	while(fabs( tempo_final - tempo ) != 0.0);
	
	cout << endl << "Tempo final: " << tempo;
	
	cout << endl << "Erro Max final: " << multi.max_erro(tempo_final) << endl;
		
	sec_fin = time( NULL );
	
	cout << "Tempo de execucao:" << sec_fin-sec_ini << "s" << endl << endl;
	
	return 1;
}