#ifndef MATRIZ_H_
#define MATRIZ_H_

template<class T>
class Matriz {
	public:
		Matriz(unsigned _nx, unsigned _ny);
		Matriz(){};
		~Matriz();
		T& operator() (unsigned _nx, unsigned _ny);
		T  operator() (unsigned _nx, unsigned _ny) const;
		T*& operator() (unsigned _nx);
		T*  operator() (unsigned _nx) const;
		Matriz& operator= (const Matriz& m);
		Matriz& operator= (int num);
		bool operator== (const Matriz& m);
		bool operator== (int num);
		Matriz& operator+= (const Matriz& m);
		unsigned int nx, ny;
		void create(unsigned _nx, unsigned _ny);
		
	private:
		T** data_;
};

template<class T>
inline Matriz<T>::Matriz(unsigned _nx, unsigned _ny):nx(_nx),ny(_ny){
	data_ = new T*[nx];
	T* temp;
	for(unsigned int i=0 ; i < ny ; i++){
		temp = new T[ny];
		data_[i] = temp;
	}
}

template<class T>
inline Matriz<T>::~Matriz(){
	for(unsigned int i = 0 ; i < nx ; i++)
		delete[] data_[i];
	delete[] data_;
}

template<class T>
inline void Matriz<T>::create(unsigned _nx, unsigned _ny){
	nx = _nx;
	ny = _ny;
		
	data_ = new T*[nx];
	T* temp;
	for(unsigned int i=0 ; i < ny ; i++){
		temp = new T[ny];
		data_[i] = temp;
	}
}

template<class T>
inline T& Matriz<T>::operator() (unsigned int _nx, unsigned int _ny){
  return data_[_nx][_ny];
}
template<class T>
inline T Matriz<T>::operator() (unsigned int _nx, unsigned int _ny) const {
  return data_[_nx][_ny];
}

template<class T>
inline T*& Matriz<T>::operator() (unsigned int _nx){
  return data_[nx];
}
template<class T>
inline T* Matriz<T>::operator() (unsigned int _nx) const {
  return data_[nx];
}


template<class T>
inline Matriz<T>& Matriz<T>::operator= (const Matriz<T>& m){
	T** temp = m.data_;
	T* linha;
	T* linha2;
	unsigned int i,j;
	for(i=0 ; i < nx ; i++){
		linha = data_[i];
		linha2 = temp[i];
		for(j=0 ; j < ny ; j++){
			linha[j] = linha2[j];
		}
	}
	return *this;
}

template<class T>
inline Matriz<T>& Matriz<T>::operator+= (const Matriz<T>& m){
	T** temp = m.data_;
	T* linha;
	T* linha2;
	unsigned int i,j;
	for(i=0 ; i < nx ; i++){
		linha = data_[i];
		linha2 = temp[i];
		for(j=0 ; j < ny ; j++){
			linha[j] += linha2[j];
		}
	}
	return *this;
}

template<class T>
inline Matriz<T>& Matriz<T>::operator= (int num){
	T* linha;
	unsigned int i,j;
	for(i=0 ; i < nx ; i++){
		linha = data_[i];
		for(j=0 ; j < ny ; j++){
			linha[j] = num;
		}
	}
	return *this;
}

template<class T>
inline bool Matriz<T>::operator== (const Matriz& m){
	T** temp = m.data_;
	T* linha;
	T* linha2;
	unsigned int i,j;
	for(i=0 ; i < nx ; i++){
		linha = data_[i];
		linha2 = temp[i];
		for(j=0 ; j < ny ; j++){
			if( linha[j] != linha2[j])
				return 0;
		}
	}
	return 1;
}

template<class T>
inline bool Matriz<T>::operator== (int num){
	T* linha;
	unsigned int i,j;
	for(i=0 ; i < nx ; i++){
		linha = data_[i];
		for(j=0 ; j < ny ; j++){
			if( linha[j] != num)
				return 0;
		}
	}
	return 1;
}

#endif /*MATRIZ_H_*/
